//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// Z poniższym kodem nie jest związana żadna gwarancja poprawności działania.
// Program został dołączony do książki ".NET CLR. Księga eksperta" w celu
// ilustracji koncepcji i zasad przedstawionych w tej książce. Program może być 
// używany na własne ryzyko.
//
// Przyznaje się prawo do użycia lub kopiowania tego oprogramowania do dowolnego celu
// bez konieczności ponoszenia żadnych opłat pod warunkiem, że powyższe uwagi zostaną 
// zachowane we wszystkich kopiach. Przyznaje się także prawo do modyfikacji kodu
// i dystrybucji zmodyfikowanego kodu pod warunkiem zachowania powyższych uwag
// oraz dołączenia informacji mówiącej o modyfikacji kodu.
//
// 
using System;
using System.Collections;
using System.Threading;

namespace DelegatesAndEvents
{
	public enum ChangeType {Add, Subtract}

	public class ChangedClass 
	{
		// Zdarzenie, które może być użyte do powiadomienia klientów o zmianie
		// elementów listy:
		public delegate void ChangeHandler(ChangeType type, int count);
		public event ChangeHandler Changed;
		private int count;
		public ChangedClass()
		{
			count = 0;
		}
		// Wywołanie zdarzenia Changed przy każdej zmianie listy:
		protected void OnChanged(ChangeType type, int count) 
		{
			if (Changed != null)
			{
				Changed(type, count);
			}
		}
		public void Add()
		{
			Interlocked.Increment(ref count);
			OnChanged(ChangeType.Add, count);
		}
		public void Subtract()
		{
			Interlocked.Decrement(ref count);
			OnChanged(ChangeType.Subtract, count);
		}
	}

	class Test 
	{
		private static void Changed(ChangeType type, int count) 
		{
			Console.WriteLine("Wywołano Changed {0} {1}", count, type);
		}
		private static void Modified(ChangeType type, int count) 
		{
			Console.WriteLine("Wywołano Modified {0} {1}", count, type);
		}
		public static void Main() 
		{
			// Utworzenie nowej listy:
			ChangedClass changed = new ChangedClass();
			changed.Changed += new ChangedClass.ChangeHandler(Changed);
			changed.Changed += new ChangedClass.ChangeHandler(Modified);
			changed.Add();
			changed.Add();
			changed.Changed -= new ChangedClass.ChangeHandler(Modified);
			changed.Add();
			changed.Add();
			changed.Subtract();
			changed.Subtract();
			changed.Subtract();
			// Delegate [] da = changed.Changed.GetInvocationList();
		}
	}
}
